/*-
 * Copyright (c) 2000
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include<stdlib.h>
#include<sys/bios.h>

#include"pie_p.h"

/*
** hiragana
*/


/*
** second Pie / Normal
*/

static pieent_t Menu_hira_k[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_a[9] = {
	{"["	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"A"	,0,NULL},	{""	,0,NULL},	{"B"	,0,NULL},
};

static pieent_t Menu_hira_y[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{NULL	,0,NULL},	{""	,0,NULL},	{"E"	,0,NULL},
};
static pieent_t Menu_hira_s[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_m[9] = {
	{"݂"	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"݂"	,0,NULL},	{""	,0,NULL},	{"݂"	,0,NULL},
};

static pieent_t Menu_hira_t[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_n[9] = {
	{"ɂ"	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"ɂ"	,0,NULL},	{""	,0,NULL},	{"ɂ"	,0,NULL},
};

static pieent_t Menu_hira_h[9] = {
	{"Ђ"	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"Ђ"	,0,NULL},	{""	,0,NULL},	{"Ђ"	,0,NULL},
};


/*
** second Pie / Shifted
*/

static pieent_t Menu_hira_g[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_r[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_x[9] = {
	{"u"	,0,NULL},	{""	,0,NULL},	{"v"	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{NULL	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_hira_z[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_f[9] = {
	{NULL	,0,NULL},	{"ӂ"	,0,NULL},	{NULL	,0,NULL},
	{NULL	,0,NULL},	{"ӂ"	,0,NULL},	{"ӂ"	,0,NULL},
	{NULL	,0,NULL},	{"ӂ"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_hira_d[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_hira_b[9] = {
	{"т"	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"т"	,0,NULL},	{""	,0,NULL},	{"т"	,0,NULL},
};

static pieent_t Menu_hira_p[9] = {
	{"҂"	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{"҂"	,0,NULL},	{""	,0,NULL},	{"҂"	,0,NULL},
};


/*
** first Pie / Normal
*/

static pieent_t Menu_hira_0[9] = {
	{"",0,Menu_hira_k},	{"",0,Menu_hira_a},	{"",0,Menu_hira_y},
	{"",0,Menu_hira_s},	{NULL	,0,NULL},	{"",0,Menu_hira_m},
	{"",0,Menu_hira_t},	{"",0,Menu_hira_n},	{"",0,Menu_hira_h},
};


/*
** first Pie / Shift
*/

static pieent_t Menu_hira_1[9] = {
	{"",0,Menu_hira_g},	{"",0,Menu_hira_r},	{"",0,Menu_hira_x},
	{"",0,Menu_hira_z},	{NULL,0,NULL},		{"ӂ",0,Menu_hira_f},
	{"",0,Menu_hira_d},	{"",0,Menu_hira_p},	{"",0,Menu_hira_b},
};
/*
** katagana
*/


/*
** second Pie / Normal
*/

static pieent_t Menu_kata_k[9] = {
	{"L"	,0,NULL},	{"L"	,0,NULL},	{NULL	,0,NULL},
	{"N"	,0,NULL},	{"J"	,0,NULL},	{"R"	,0,NULL},
	{"L"	,0,NULL},	{"P"	,0,NULL},	{"L"	,0,NULL},
};

static pieent_t Menu_kata_a[9] = {
	{"["	,0,NULL},	{"C"	,0,NULL},	{NULL	,0,NULL},
	{"E"	,0,NULL},	{"A"	,0,NULL},	{"I"	,0,NULL},
	{"A"	,0,NULL},	{"G"	,0,NULL},	{"B"	,0,NULL},
};

static pieent_t Menu_kata_y[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{"b"	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{NULL	,0,NULL},	{""	,0,NULL},	{"E"	,0,NULL},
};
static pieent_t Menu_kata_s[9] = {
	{"V"	,0,NULL},	{"V"	,0,NULL},	{NULL	,0,NULL},
	{"X"	,0,NULL},	{"T"	,0,NULL},	{"\"	,0,NULL},
	{"V"	,0,NULL},	{"Z"	,0,NULL},	{"V"	,0,NULL},
};

static pieent_t Menu_kata_m[9] = {
	{"~"	,0,NULL},	{"~"	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{"}"	,0,NULL},	{""	,0,NULL},
	{"~"	,0,NULL},	{""	,0,NULL},	{"~"	,0,NULL},
};

static pieent_t Menu_kata_t[9] = {
	{"`"	,0,NULL},	{"`"	,0,NULL},	{NULL	,0,NULL},
	{"c"	,0,NULL},	{"^"	,0,NULL},	{"g"	,0,NULL},
	{"`"	,0,NULL},	{"e"	,0,NULL},	{"`"	,0,NULL},
};

static pieent_t Menu_kata_n[9] = {
	{"j"	,0,NULL},	{"j"	,0,NULL},	{NULL	,0,NULL},
	{"k"	,0,NULL},	{"i"	,0,NULL},	{"m"	,0,NULL},
	{"j"	,0,NULL},	{"l"	,0,NULL},	{"j"	,0,NULL},
};

static pieent_t Menu_kata_h[9] = {
	{"q"	,0,NULL},	{"q"	,0,NULL},	{NULL	,0,NULL},
	{"t"	,0,NULL},	{"n"	,0,NULL},	{"z"	,0,NULL},
	{"q"	,0,NULL},	{"w"	,0,NULL},	{"q"	,0,NULL},
};


/*
** second Pie / Shifted
*/

static pieent_t Menu_kata_g[9] = {
	{"M"	,0,NULL},	{"M"	,0,NULL},	{NULL	,0,NULL},
	{"O"	,0,NULL},	{"K"	,0,NULL},	{"S"	,0,NULL},
	{"M"	,0,NULL},	{"Q"	,0,NULL},	{"M"	,0,NULL},
};

static pieent_t Menu_kata_r[9] = {
	{""	,0,NULL},	{""	,0,NULL},	{NULL	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
	{""	,0,NULL},	{""	,0,NULL},	{""	,0,NULL},
};

static pieent_t Menu_kata_x[9] = {
	{"u"	,0,NULL},	{"B"	,0,NULL},	{"v"	,0,NULL},
	{"D"	,0,NULL},	{"@"	,0,NULL},	{"H"	,0,NULL},
	{NULL	,0,NULL},	{"F"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_kata_z[9] = {
	{"W"	,0,NULL},	{"W"	,0,NULL},	{NULL	,0,NULL},
	{"Y"	,0,NULL},	{"U"	,0,NULL},	{"]"	,0,NULL},
	{"W"	,0,NULL},	{"["	,0,NULL},	{"W"	,0,NULL},
};

static pieent_t Menu_kata_f[9] = {
	{NULL	,0,NULL},	{"tB"	,0,NULL},	{NULL	,0,NULL},
	{NULL	,0,NULL},	{"t@"	,0,NULL},	{"tH"	,0,NULL},
	{NULL	,0,NULL},	{"tF"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_kata_d[9] = {
	{"a"	,0,NULL},	{"a"	,0,NULL},	{NULL	,0,NULL},
	{"d"	,0,NULL},	{"_"	,0,NULL},	{"h"	,0,NULL},
	{"a"	,0,NULL},	{"f"	,0,NULL},	{"a"	,0,NULL},
};

static pieent_t Menu_kata_b[9] = {
	{"r"	,0,NULL},	{"r"	,0,NULL},	{NULL	,0,NULL},
	{"u"	,0,NULL},	{"o"	,0,NULL},	{"{"	,0,NULL},
	{"r"	,0,NULL},	{"x"	,0,NULL},	{"r"	,0,NULL},
};

static pieent_t Menu_kata_p[9] = {
	{"s"	,0,NULL},	{"s"	,0,NULL},	{NULL	,0,NULL},
	{"v"	,0,NULL},	{"p"	,0,NULL},	{"|"	,0,NULL},
	{"s"	,0,NULL},	{"y"	,0,NULL},	{"s"	,0,NULL},
};


/*
** first Pie / Normal
*/

static pieent_t Menu_kata_0[9] = {
	{"J",0,Menu_kata_k},	{"A",0,Menu_kata_a},	{"",0,Menu_kata_y},
	{"T",0,Menu_kata_s},	{NULL	,0,NULL},	{"}",0,Menu_kata_m},
	{"^",0,Menu_kata_t},	{"i",0,Menu_kata_n},	{"n",0,Menu_kata_h},
};


/*
** first Pie / Shift
*/

static pieent_t Menu_kata_1[9] = {
	{"K",0,Menu_kata_g},	{"",0,Menu_kata_r},	{"@",0,Menu_kata_x},
	{"U",0,Menu_kata_z},	{NULL,0,NULL},		{"t@",0,Menu_kata_f},
	{"_",0,Menu_kata_d},	{"p",0,Menu_kata_p},	{"o",0,Menu_kata_b},
};
/*
** ascii
*/

/*
** second Pie / Normal
*/

static pieent_t Menu_asc_a[9] = {
	{NULL	,0,NULL},	{"b"	,0,NULL},	{NULL	,0,NULL},
	{"c"	,0,NULL},	{"a"	,0,NULL},	{"e"	,0,NULL},
	{NULL	,0,NULL},	{"d"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_6[9] = {
	{"-"	,0,NULL},	{"7"	,0,NULL},	{NULL	,0,NULL},
	{"8"	,0,NULL},	{"6"	,0,NULL},	{"0"	,0,NULL},
	{"="	,0,NULL},	{"9"	,0,NULL},	{"\\"	,0,NULL},
};

static pieent_t Menu_asc_f[9] = {
	{","	,0,NULL},	{"g"	,0,NULL},	{NULL	,0,NULL},
	{"h"	,0,NULL},	{"f"	,0,NULL},	{"j"	,0,NULL},
	{"."	,0,NULL},	{"i"	,0,NULL},	{";"	,0,NULL},
};

static pieent_t Menu_asc_1[9] = {
	{"["	,0,NULL},	{"2"	,0,NULL},	{NULL	,0,NULL},
	{"3"	,0,NULL},	{"1"	,0,NULL},	{"5"	,0,NULL},
	{"]"	,0,NULL},	{"4"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_k[9] = {
	{NULL	,0,NULL},	{"l"	,0,NULL},	{NULL	,0,NULL},
	{"m"	,0,NULL},	{"k"	,0,NULL},	{"o"	,0,NULL},
	{NULL	,0,NULL},	{"n"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_p[9] = {
	{"'"	,0,NULL},	{"q"	,0,NULL},	{NULL	,0,NULL},
	{"r"	,0,NULL},	{"p"	,0,NULL},	{"t"	,0,NULL},
	{"`"	,0,NULL},	{"s"	,0,NULL},	{"/"	,0,NULL},
};

static pieent_t Menu_asc_u[9] = {
	{NULL	,0,NULL},	{"v"	,0,NULL},	{NULL	,0,NULL},
	{"w"	,0,NULL},	{"u"	,0,NULL},	{"o"	,0,NULL},
	{"x"	,0,NULL},	{"y"	,0,NULL},	{"z"	,0,NULL},
};


/*
** second Pie / shift
*/

static pieent_t Menu_asc_A[9] = {
	{NULL	,0,NULL},	{"B"	,0,NULL},	{NULL	,0,NULL},
	{"C"	,0,NULL},	{"A"	,0,NULL},	{"E"	,0,NULL},
	{NULL	,0,NULL},	{"D"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_6s[9] = {
	{"_"	,0,NULL},	{"&"	,0,NULL},	{NULL	,0,NULL},
	{"*"	,0,NULL},	{"^"	,0,NULL},	{")"	,0,NULL},
	{"+"	,0,NULL},	{"("	,0,NULL},	{"|"	,0,NULL},
};

static pieent_t Menu_asc_F[9] = {
	{"<"	,0,NULL},	{"G"	,0,NULL},	{NULL	,0,NULL},
	{"H"	,0,NULL},	{"F"	,0,NULL},	{"J"	,0,NULL},
	{">"	,0,NULL},	{"I"	,0,NULL},	{":"	,0,NULL},
};

static pieent_t Menu_asc_1s[9] = {
	{"{"	,0,NULL},	{"@"	,0,NULL},	{NULL	,0,NULL},
	{"#"	,0,NULL},	{"!"	,0,NULL},	{"%"	,0,NULL},
	{"}"	,0,NULL},	{"$"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_K[9] = {
	{NULL	,0,NULL},	{"L"	,0,NULL},	{NULL	,0,NULL},
	{"M"	,0,NULL},	{"K"	,0,NULL},	{"O"	,0,NULL},
	{NULL	,0,NULL},	{"N"	,0,NULL},	{NULL	,0,NULL},
};

static pieent_t Menu_asc_P[9] = {
	{"\""	,0,NULL},	{"Q"	,0,NULL},	{NULL	,0,NULL},
	{"R"	,0,NULL},	{"P"	,0,NULL},	{"T"	,0,NULL},
	{"~"	,0,NULL},	{"S"	,0,NULL},	{"?"	,0,NULL},
};

static pieent_t Menu_asc_U[9] = {
	{NULL	,0,NULL},	{"V"	,0,NULL},	{NULL	,0,NULL},
	{"W"	,0,NULL},	{"U"	,0,NULL},	{"O"	,0,NULL},
	{"X"	,0,NULL},	{"Y"	,0,NULL},	{"Z"	,0,NULL},
};


/*
** first Pie / Normal
*/

static pieent_t Menu_ascii_0[9] = {
	{"a",0,Menu_asc_a},	{"6",0,Menu_asc_6},	{NULL,0,NULL},
	{"f",0,Menu_asc_f},	{NULL	,0,NULL},	{"1",0,Menu_asc_1},
	{"k",0,Menu_asc_k},	{"p",0,Menu_asc_p},	{"u",0,Menu_asc_u},
};


/*
** first Pie / Shift
*/

static pieent_t Menu_ascii_1[9] = {
	{"A",0,Menu_asc_A},	{"^",0,Menu_asc_6s},	{NULL,0,NULL},
	{"F",0,Menu_asc_F},	{NULL	,0,NULL},	{"!",0,Menu_asc_1s},
	{"K",0,Menu_asc_K},	{"P",0,Menu_asc_P},	{"U",0,Menu_asc_U},
};
/*
** Pies
*/

pieent_t *PieMenu[PIE_NUM_MODE][2] = {
	{ Menu_hira_0, Menu_hira_1,},
	{ Menu_kata_0, Menu_kata_1,},
	{ Menu_ascii_0, Menu_ascii_1,},
};
